﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9
@EndOfDesignText@
'Author: Brandsum
'Version: 1.21

#DesignerProperty: Key: DotColor, DisplayName: Dots Color, FieldType: Color, DefaultValue: 0xFFCCCCCC, Description: Dots color.
#DesignerProperty: Key: ActiveDotColor, DisplayName: Active Dots Color, FieldType: Color, DefaultValue: 0xFF4286f4, Description: Active Dots color.
#DesignerProperty: Key: Fit, DisplayName: Fit Image, FieldType: Boolean, DefaultValue: True, Description: Fit image to the slider maintaining aspect ratio. 
#DesignerProperty: Key: CoverFreeSpace, DisplayName: Cover Free Space, FieldType: Boolean, DefaultValue: True, Description: Show a blurry image around the slide image if there is any free space. Only applicable if Fit Image is checked. 
#DesignerProperty: Key: FreeSpaceColor, DisplayName: Free Space Color, FieldType: Color, DefaultValue: 0xFFF4F4F4, Description: Show solid color around the slide image if there is any free space. Only applicable if Cover Free Space is unchecked. 
#DesignerProperty: Key: ImageCount, DisplayName: Item Count, FieldType: Boolean, DefaultValue: True, Description: Show item count label (Eg. 5/10). 
#DesignerProperty: Key: dotTransitionDuration, DisplayName: Dot Transition Duration, FieldType: Int, DefaultValue: 500, Description: Dots transition time in milliseconds.
#DesignerProperty: Key: ZoomActualSlide, DisplayName: Zoom Actual View, FieldType: Boolean, DefaultValue: True, Description: If checked the item will be hidden while zooming (Like Instagram).

#Event: PageChanged(CurrentIndex As Int)
#Event: SingleTap(CurrentIndex As Int, Data As Object)
#Event: DoubleTap(CurrentIndex As Int, Data As Object)

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	#if b4i
	Private ImgCont As ScrollView
	#else if b4a
	Private Imgcont As AHViewPager
	Private imgLayout As AHPageContainer
	Private GesturePanel As Panel
	#end if
	Private ImgCount As Label
	Private ImgList As List
	
	Public CurrentIndex As Int = 0
	Private PrevIndex As Int = 0
	Private dotTransitionDuration As Int
	
	Private dotCont As B4XView
	Private dotColor,activeDotColor As Int
	Private dotSize As Int = 6dip
	Private dotSizeM As Int = 5dip
	Private dotSizeS As Int = 3dip
	Private dotgap As Int = dotSize
	Private fit,ImageCount,CoverFreeSpace,ZoomActualSlide As Boolean
	Public activityHasActionBar As Boolean = True
	
	Private LblTimer As Timer
	
	#if b4a
	Private GD As GestureDetector
	Private JO As JavaObject
	#else if b4i
	Private GD As NativeObject=Me
	#End If
	
	Private ZoomContainer,ZoomPanel As B4XView
	Private PinchStartDistance,PinchFixX,PinchFixY,ZoomWindowFix As Double = 0
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	ImgList.Initialize
	ZoomPanel = xui.CreatePanel("ZoomPanel")
	
	ImgCount.Initialize("")
	dotCont = xui.CreatePanel("")
	LblTimer.Initialize("LblTimer",2000)
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	dotColor = xui.PaintOrColorToColor(Props.Get("DotColor"))
	activeDotColor = xui.PaintOrColorToColor(Props.Get("ActiveDotColor"))
	fit = Props.Get("Fit")
	ImageCount = Props.Get("ImageCount")
	CoverFreeSpace = Props.Get("CoverFreeSpace")
	ZoomActualSlide = Props.Get("ZoomActualSlide")
	dotTransitionDuration = Props.Get("dotTransitionDuration")
	
	mBase = Base
	mBase.Color = xui.Color_Transparent
	#if b4i
	ImgCont.Initialize("ImgCont",mBase.Width,(mBase.Height-30dip))
	ImgCont.PagingEnabled=True
	ImgCont.Bounces = False
	ImgCont.ShowsHorizontalIndicator = False
	#else if b4a
	Imgcont.Initialize("ImgCont")
	#end if
	mBase.AddView(Imgcont,0,0,mBase.Width,(mBase.Height-30dip))
	
	#if b4a
	GesturePanel = xui.CreatePanel("")
	mBase.addview(GesturePanel,0,0,mBase.Width,(mBase.Height-30dip))
	GD.SetOnGestureListener(GesturePanel,"ImgCont_GD")
	
	'JO.InitializeContext
	'If activityHasActionBar Then ZoomWindowFix = JO.RunMethodJO("getActionBar",Null).RunMethod("getHeight",Null)
	'ZoomWindowFix = ZoomWindowFix + JO.RunMethodJO("getResources",Null).RunMethod("getDimensionPixelSize",Array As Object (JO.RunMethodJO("getResources",Null).RunMethod("getIdentifier",Array As Object ("status_bar_height", "dimen", "android"))))
	'JO = mBase
	#else if b4i
	
	Dim NO As NativeObject = Main.NavControl
	If activityHasActionBar Then ZoomWindowFix = NO.ArrayFromRect(NO.GetField("navigationBar").GetField("frame").RunMethod("CGRectValue", Null))(3)
	ZoomWindowFix = ZoomWindowFix + GD.RunMethod("statusBarHeight",Null).AsNumber
	#End If
	
	mBase.AddView(xui.CreatePanel(""),(mBase.Width - 10dip) + 1dip,10dip,1dip,25dip)
	mBase.GetView(mBase.NumberOfViews-1).AddView(ImgCount,0,0,1dip,25dip)
	Private tempView As B4XView = ImgCount
	tempView.TextColor = xui.Color_White
	tempView.TextSize = 12
	tempView.SetTextAlignment("CENTER","CENTER")
	tempView.Parent.Visible = False
	
	mBase.AddView(dotCont,0,mBase.Height - 30dip, mBase.Width,30dip)
	
	ZoomPanel.Color = xui.Color_ARGB(30,0,0,0)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub

#if b4a
Private Sub ImgCont_GD_onSingleTapConfirmed(X As Float, Y As Float, MotionEvent As Object)
	If xui.SubExists(mCallBack, mEventName & "_SingleTap",2) Then
		Private currentView As B4XView = ImgList.Get(CurrentIndex)
		Private tagmap As Map = currentView.Tag
		CallSub3(mCallBack, mEventName & "_SingleTap",CurrentIndex,tagmap.Get("data"))
	End If
End Sub

Private Sub ImgCont_GD_onDoubleTap(X As Float, Y As Float, MotionEvent As Object)
	If xui.SubExists(mCallBack, mEventName & "_DoubleTap",2) Then
		Private currentView As B4XView = ImgList.Get(CurrentIndex)
		Private tagmap As Map = currentView.Tag
		CallSub3(mCallBack, mEventName & "_DoubleTap",CurrentIndex,tagmap.Get("data"))
	End If
End Sub
#else if b4i
Private Sub uigesture_tap(numTaps As Int, numTouch As Int)
	If numTaps = 2 Then
		If xui.SubExists(mCallBack, mEventName & "_DoubleTap",2) Then
			Private currentView As B4XView = ImgList.Get(CurrentIndex)
			Private tagmap As Map = currentView.Tag
			CallSub3(mCallBack, mEventName & "_DoubleTap",CurrentIndex,tagmap.Get("data"))
		End If
	else if numTaps =1 Then
		If xui.SubExists(mCallBack, mEventName & "_SingleTap",2) Then
			Private currentView As B4XView = ImgList.Get(CurrentIndex)
			Private tagmap As Map = currentView.Tag
			CallSub3(mCallBack, mEventName & "_SingleTap",CurrentIndex,tagmap.Get("data"))
		End If
	End If
End Sub
#end if

#if b4a

Private Sub ImgCont_GD_onTouch(Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean	
	If Action = mBase.TOUCH_ACTION_UP Then
		ZoomPanel.RemoveViewFromParent
		ZoomPanel.RemoveAllViews
		If ZoomActualSlide Then
			Private actualView As B4XView = ImgList.Get(CurrentIndex)
			actualView.SetVisibleAnimated(200,True)
		End If
		StopPropagation(False)
	End If
	GD.PassTouchEventTo(MotionEvent,Imgcont)
	Return True
End Sub

Private Sub ImgCont_GD_onPinchClose(NewDistance As Float, PreviousDistance As Float, MotionEvent As Object)
	StopPropagation(True)
	If ZoomContainer.IsInitialized Then
		If ZoomPanel.Parent.IsInitialized Then
			ZoomImage(NewDistance,MotionEvent)
		End If
	End If
End Sub

Private Sub ImgCont_GD_onPinchOpen(NewDistance As Float, PreviousDistance As Float, MotionEvent As Object)
	StopPropagation(True)
#else if b4i
Private Sub uigesture_pinch(NewDistance As Float, x As Float,y As Float, action As Int)
#end if
	If ZoomContainer.IsInitialized Then
		If Not(ZoomPanel.Parent.IsInitialized) Then
			ZoomContainer.AddView(ZoomPanel,0,0,ZoomContainer.width,ZoomContainer.Height)
			Private actualView As B4XView = ImgList.Get(CurrentIndex)
			#if b4i
			Private tempView As ImageView
			tempView.Initialize("")
			tempView.ContentMode = tempView.MODE_FILL
			tempView.Bitmap = actualView.Snapshot
			PinchFixX = (actualView.Width/2) - x
			PinchFixY = (actualView.Height/2) - y
			Private NO As NativeObject = Me
			Private location(2) As Float = NO.ArrayFromPoint(NO.RunMethod("getLocationInWindow::",Array(ImgCont,actualView)))
			#else if b4a
			Private location(2) As Int
			JO.RunMethod("getLocationInWindow",Array As Object(location))
			Private tempView As Panel = xui.CreatePanel("yy")
			tempView.SetBackgroundImage(actualView.Snapshot).Gravity = Gravity.FILL
			PinchFixX = (actualView.Width/2) - (Min(GD.getX(MotionEvent,1),GD.getX(MotionEvent,0)) + Abs(GD.getX(MotionEvent,0) - GD.getX(MotionEvent,1))/2)
			PinchFixY = (actualView.Height/2) - (Min(GD.getY(MotionEvent,1),GD.getY(MotionEvent,0)) + Abs(GD.getY(MotionEvent,0) - GD.getY(MotionEvent,1))/2)
			#End If
			ZoomPanel.AddView(tempView,location(0),location(1) - ZoomWindowFix,actualView.Width,actualView.Height)
			PinchStartDistance = NewDistance
		Else
			#if b4a
			ZoomImage(NewDistance,MotionEvent)
			#else if b4i
			ZoomImage(NewDistance,x,y)
			If action = 3 Then
				ZoomPanel.RemoveViewFromParent
				ZoomPanel.RemoveAllViews
				If ZoomActualSlide Then
					Private actualView As B4XView = ImgList.Get(CurrentIndex)
					actualView.SetVisibleAnimated(200,True)
				End If
			End If
			#End If
		End If
	End If
End Sub

Private Sub LblTimer_tick
	Private i As B4XView = ImgCount.parent
	i.SetVisibleAnimated(500,False)
	LblTimer.Enabled = False
End Sub

#Region Functions
#if b4a
Private Sub StopPropagation(Enable As Boolean)
	Private j As JavaObject = GesturePanel
	j.RunMethod("requestDisallowInterceptTouchEvent",Array As Object(Enable))
End Sub
#end if

#if b4a
Private Sub ZoomImage(Distance As Float, MotionEvent As Object)
	Private centerX As Int = Min(GD.getX(MotionEvent,1),GD.getX(MotionEvent,0)) + Abs(GD.getX(MotionEvent,0) - GD.getX(MotionEvent,1))/2
	Private centerY As Int = Min(GD.getY(MotionEvent,1),GD.getY(MotionEvent,0)) + Abs(GD.getY(MotionEvent,0) - GD.getY(MotionEvent,1))/2
	Private location(2) As Int
	JO.RunMethod("getLocationInWindow",Array As Object(location))
	Private actualView As B4XView = ImgList.Get(CurrentIndex)
#else if b4i
Private Sub ZoomImage(Distance As Float, centerX As Int, centerY As Int)
	Private actualView As B4XView = ImgList.Get(CurrentIndex)
	Private NO As NativeObject = Me
	Private location(2) As Float = NO.ArrayFromPoint(NO.RunMethod("getLocationInWindow::",Array(ImgCont,actualView)))
#end if
	If ZoomActualSlide Then actualView.Visible = False
	Private newWidth As Int = Max(actualView.Width,(Distance/PinchStartDistance)*actualView.Width)
	Private newHeight As Int = Max(actualView.Height,(Distance/PinchStartDistance)*actualView.Height)
	ZoomPanel.GetView(0).SetLayoutAnimated(10,(centerX+location(0)) - (newWidth/2) + (PinchFixX * (Distance/PinchStartDistance)),(centerY+location(1)) - (newHeight/2) + (PinchFixY * (Distance/PinchStartDistance)) - ZoomWindowFix,newWidth,newHeight)
End Sub

Private Sub SlideImage(centerIndex As Int)
	#if b4i
	ImgCont.ScrollTo(ImgCont.Width*centerIndex,0,True)
	#else b4a
	Imgcont.GotoPage(Imgcont.Width*centerIndex,True)
	#end if
End Sub

#if b4i
Private Sub ImgCont_ScrollChanged (OffsetX As Int, OffsetY As Int)
	Dim centerIndex As Int = 0
	If OffsetX > 0 Then 
		centerIndex = OffsetX/ImgCont.width
	End If
	
	If OffsetX = centerIndex*ImgCont.width Then
#else if b4a
Private Sub ImgCont_PageChanged (Position As Int)
	Dim centerIndex As Int = Position
#end if
		If CurrentIndex <> centerIndex Then
			PrevIndex = CurrentIndex
			CurrentIndex = centerIndex
			ShowCount
			UpdateDots
		End If
#if b4i
	End If
#end if

	If xui.SubExists(mCallBack, mEventName & "_PageChanged",1) Then
		CallSub2(mCallBack, mEventName & "_PageChanged",CurrentIndex)
	End If
	ShowImage
End Sub

Private Sub ShowCount
	If ImageCount Then
		Private tempView As B4XView = ImgCount
		tempView.Text = (CurrentIndex+1) & "/" & ImgList.Size
		Private tempCanvas As B4XCanvas
		tempCanvas.Initialize(ImgCount) 
		Private textSize As B4XRect = tempCanvas.MeasureText(tempView.Text,tempView.Font)
		
		tempView.parent.SetLayoutAnimated(100,(ImgCont.Width - 10dip)-(textSize.Width+20dip),tempView.Parent.Top,(textSize.Width+20dip),tempView.parent.Height)
		tempView.SetLayoutAnimated(0,0,0,(textSize.Width+20dip),tempView.Height)
		tempView.SetColorAndBorder(xui.Color_ARGB(150,0,0,0),0,xui.Color_Transparent,tempView.Height)
		#if b4i
		ImgCount.SetBorder(0,xui.Color_Transparent,ImgCount.Height/2)
		#End If
		tempView.Parent.SetVisibleAnimated(500,True)
		LblTimer.Enabled = False
		LblTimer.Enabled = True
	End If
End Sub

Private Sub UpdateDots
	Private shift As Int = dotSize+dotgap
	If (CurrentIndex = 5 Or CurrentIndex = dotCont.NumberOfViews -1 Or CurrentIndex = dotCont.NumberOfViews -6) And dotCont.GetView(CurrentIndex).Tag = "s" Then
		'shift = (shift/2)
	End If
	For i=0 To dotCont.NumberOfViews-1
		Private dot As B4XView = dotCont.GetView(i)
		Private dotCir As B4XView = dot.getview(0)
		dotCir.SetColorAndBorder(dotColor,0,xui.Color_Transparent,dotSize)
		
		If CurrentIndex > PrevIndex Then
			If dotCont.GetView(CurrentIndex).Tag = "s" Then
				
				If i = CurrentIndex Then
					SetActive(dot)
				Else If i = CurrentIndex-5 Or i = CurrentIndex+1 Then
					SetSmall(dot)
				Else If i < CurrentIndex-5 Or i > CurrentIndex+1 Then
					SetHidden(dot)
				Else
					SetDefault(dot)
				End If
				dot.SetLayoutAnimated(dotTransitionDuration,dot.left-shift,dot.top,dotSize,dotSize)
			Else
				If i = CurrentIndex Then
					SetActive(dot)
				Else if dot.tag = "b" Then
					SetDefault(dot)
				End If
			End If
		Else If CurrentIndex < PrevIndex Then
			If dotCont.GetView(CurrentIndex).tag = "s" Then
				If i = CurrentIndex Then
					SetActive(dot)
				Else If i = CurrentIndex-1 Or i = CurrentIndex+5 Then
					SetSmall(dot)
				Else If i < CurrentIndex-1 Or i > CurrentIndex+5 Then
					SetHidden(dot)
				Else
					SetDefault(dot)
				End If
				dot.SetLayoutAnimated(dotTransitionDuration,dot.left+shift,dot.top,dotSize,dotSize)
			Else
				If i = CurrentIndex Then
					SetActive(dot)
				Else if dot.tag = "b" Then
					SetDefault(dot)
				End If
			End If
		End If
	Next
	
	dotCont.GetView(CurrentIndex).Tag = "b"
End Sub

Private Sub SetActive(dot As B4XView)
	Private dotCir As B4XView = dot.GetView(0)
	dotCir.SetColorAndBorder(activeDotColor,0,xui.Color_Transparent,dotSize)
	dotCir.SetLayoutAnimated(dotTransitionDuration,0,0,dotSize,dotSize)
End Sub

Private Sub SetDefault(dot As B4XView)
	Private dotCir As B4XView = dot.GetView(0)
	dotCir.SetLayoutAnimated(dotTransitionDuration,(dotSize-dotSizeM)/2,(dotSize-dotSizeM)/2,dotSizeM,dotSizeM)
End Sub

Private Sub SetSmall(dot As B4XView)
	Private dotCir As B4XView = dot.GetView(0)
	dotCir.SetLayoutAnimated(dotTransitionDuration,(dotSize/2)-(dotSizeS/2),(dotSize/2)-(dotSizeS/2),dotSizeS,dotSizeS)
	dotCir.SetVisibleAnimated(dotTransitionDuration,True)
	
	dot.tag = "s"
End Sub

Private Sub SetHidden(dot As B4XView)
	Private dotCir As B4XView = dot.GetView(0)
	dotCir.SetLayoutAnimated(dotTransitionDuration,dotSize/2,dotSize/2,1,1)
	dotCir.SetVisibleAnimated(dotTransitionDuration,False)
	dot.tag = "h"
End Sub

Private Sub ShowImage
	Dim i As B4XView = ImgList.Get(CurrentIndex)
	Dim imagedata As Map = i.Tag
	Dim img As B4XBitmap
	
	If imagedata.Get("image") Is String Then
		
		#if b4a
		If i.GetView(i.NumberOfViews-1) Is ProgressBar Then
			Dim p As ProgressBar = i.GetView(i.NumberOfViews-1)
			p.RemoveView
		#else if b4i
		If i.GetView(i.NumberOfViews-1) Is ActivityIndicator Then
			Dim p As ActivityIndicator = i.GetView(i.NumberOfViews-1)
			p.RemoveViewFromParent
		#End If
		End If
		If i.GetView(i.NumberOfViews-1) Is Label Then
			Dim l As Label = i.GetView(i.NumberOfViews-1)
			#if b4a
			l.RemoveView
			#else if b4i
			l.RemoveViewFromParent
			#end if
		End If
		
		#if b4a
		Dim p As ProgressBar
		#else if b4i
		Dim p As ActivityIndicator
		#End If
		#if b4a
		p.Initialize("")
		p.Indeterminate = True
		#else if b4i
		p.Initialize
		#end if
		i.AddView(p,Imgcont.Width/2 - 20dip,Imgcont.height/2 - 20dip,40dip,40dip)
		
		Dim j As HttpJob
		j.Initialize("",Me)
		j.Download(imagedata.Get("image"))
		Wait For (j) JobDone(j As HttpJob)
		#if b4a
		p.RemoveView
		#else if b4i
		p.RemoveViewFromParent
		#end if
		If j.Success Then
			Dim img As B4XBitmap = j.GetBitmap
			i.Tag = CreateMap("image":img,"data":imagedata.Get("data"))
		End If
	Else
		Dim img As B4XBitmap = imagedata.Get("image")
	End If
	
	If i.GetView(i.NumberOfViews-1) Is Label Then
		Dim l As Label = i.GetView(i.NumberOfViews-1)
		#if b4a
		l.RemoveView
		#else if b4i
		l.RemoveViewFromParent
		#end if
	End If
	
	If img.IsInitialized Then
		If fit Then
			If CoverFreeSpace Then
				#if b4a
					i.SetBitmap(img.Resize(10dip,10dip,False).Resize(Imgcont.Width,Imgcont.Height,False))
					i.GetView(0).SetBitmap(img.Resize(Imgcont.Width,Imgcont.Height,True))
				#else if b4i
					i.GetView(0).SetBitmap(img.Resize(10dip,10dip,False).Resize(ImgCont.Width,ImgCont.Height,False))
					i.GetView(1).SetBitmap(img.Resize(ImgCont.Width,ImgCont.Height,True))
				#End If
			Else
				#if b4a
					i.SetBitmap(img.Resize(Imgcont.Width,Imgcont.Height,True))
				#else if b4i
					i.GetView(0).SetBitmap(img.Resize(ImgCont.Width,ImgCont.Height,True))
				#end if
			End If
		Else
			#if b4a
				i.SetBitmap(img.Resize(Imgcont.Width,Imgcont.Height,False))
			#else if b4i
				i.GetView(0).SetBitmap(img.Resize(ImgCont.Width,ImgCont.Height,False))
			#end if
		End If
	Else
		Dim tp As Label
		tp.Initialize("trypanel")
		i.AddView(tp,0,0,ImgCont.Width,ImgCont.Height)
		tp.Text = "Couldn't load image. Tap to retry."
		tp.Color = Colors.White
		tp.TextColor = Colors.Black
		#if b4a
			tp.Gravity = Gravity.CENTER_HORIZONTAL+Gravity.CENTER_VERTICAL
			tp.TextSize = 15
		#else if b4i
			tp.TextAlignment = tp.ALIGNMENT_CENTER
			tp.Font = Font.CreateNew(15)
		#End If
	End If
End Sub

Private Sub trypanel_Click
	Dim l As Label = Sender
	#if b4a
	l.RemoveView
	#else if b4i
	l.RemoveViewFromParent
	#end if
	ShowImage
End Sub

#End Region

#Region UserFunctions
Public Sub SetImages(imgs As List)
	CurrentIndex = 0
	dotCont.RemoveAllViews
	ImgList.Initialize
	#if b4a
	imgLayout.Initialize
	For Each img As Map In imgs
		Private i As B4XView = xui.CreatePanel("")
		i.Tag = img
	#else if b4i
	ImgCont.Panel.RemoveAllViews
	For Each img As Map In imgs
		Private i As B4XView = xui.CreatePanel("")
		GD.RunMethod("gestureTap:::",Array(1,1,i))'single
		GD.RunMethod("gestureTap:::",Array(2,1,i))'double
		GD.RunMethod("gesturePinch:",Array(i))
		i.Tag = img
		
		Private itmp As ImageView
		itmp.Initialize("")
		i.AddView(itmp,0,0,ImgCont.Width,ImgCont.Height)
	#End If
		If fit Then
			If CoverFreeSpace Then
				#if b4a
				Private ii As B4XView = xui.CreatePanel("")
				#else if b4i
				Private iitmp As ImageView:iitmp.Initialize("")
				Private ii As B4XView = iitmp
				#End If
				i.AddView(ii,0,0,ImgCont.Width,ImgCont.Height)
			End If
		End If
		#if b4i
		ImgCont.Panel.AddView(i,(ImgCont.Width * ImgList.Size),0,ImgCont.Width,ImgCont.Height)
		#else if b4a
		Dim  tempi As Panel = xui.createPanel("")
		tempi.SetLayoutAnimated(0,0,0,Imgcont.Width,Imgcont.Height)
		tempi.addView(i,0,0,Imgcont.Width,Imgcont.Height)
		imgLayout.AddPage(tempi,"")
		#end if
		ImgList.Add(i)
	Next
	#if b4i
	ImgCont.ContentWidth = imgs.Size*ImgCont.width
	ImgCont.ScrollOffsetX = 0
	#else if b4a
	Imgcont.PageContainer = imgLayout
	#end if
	
	If imgs.Size > 1 Then
		Private dotStartX As Int = (dotCont.width/2) - ((((Min(6,imgs.Size)*dotSize) + (Min(6,imgs.Size)*dotgap))-dotgap)/2)
		For j=0 To imgs.Size-1
			Private p As B4XView = xui.CreatePanel("")
			Private size As Int = dotSizeM
			p.Tag = "b"
			If j=5 Then
				size = dotSizeS
				p.Tag = "s"
			else if j > 5 Then
				size = 0
				p.Tag = "h"
			End If
			
			dotCont.AddView(p,dotStartX + (j*(dotSize+dotgap)),((dotCont.Height/2)-(dotSize/2)),dotSize,dotSize)
			Private q As B4XView = xui.CreatePanel("")
			
			If j=0 Then
				q.SetColorAndBorder(activeDotColor,0,xui.Color_Transparent,dotSize)
				p.AddView(q,0,0,dotSize,dotSize)
			Else
				q.SetColorAndBorder(dotColor,0,xui.Color_Transparent,dotSize)
				p.AddView(q,(dotSize-size)/2,(dotSize-size)/2,size,size)
			End If
		Next
	End If
	
	ShowCount
	ShowImage
End Sub

Public Sub SetZoomPanel(ZoomPanelContainer As B4XView)
	ZoomContainer=ZoomPanelContainer
End Sub

Public Sub ShowNext
	If CurrentIndex < ImgList.Size-1 Then
		SlideImage(CurrentIndex +1)
	End If
End Sub

Public Sub ShowPrev
	If CurrentIndex > 0 Then
		SlideImage(CurrentIndex -1)
	End If
End Sub
#End Region


#If OBJC

- (BOOL)gestureRecognizer:(UIGestureRecognizer *)gestureRecognizer shouldRecognizeSimultaneouslyWithGestureRecognizer:(UIGestureRecognizer *)otherGestureRecognizer
{return TRUE;}

-(void)gestureTap: (int)numtaps :(int)numtouch :(UIView*)v
{
	UITapGestureRecognizer *Tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTap:)];
	Tap.delegate=self;
	[Tap setNumberOfTapsRequired:numtaps];
	[Tap setNumberOfTouchesRequired:numtouch];
	[v addGestureRecognizer:Tap];
}

- (void)handleTap:(UITapGestureRecognizer *)gestureRecognizer {
    int numtouch =gestureRecognizer.numberOfTouchesRequired;
    int numtap =gestureRecognizer.numberOfTapsRequired;
    [self.bi raiseEvent:nil event:@"uigesture_tap::" params:@[@((int)numtap),@((int)numtouch)]];

}  

-(void)gesturePinch :(UIView*)v
{
	UIPinchGestureRecognizer *pinch = [[UIPinchGestureRecognizer alloc] initWithTarget:self  action:@selector(handlePinch:)];
	pinch.delegate=self;
 	[v addGestureRecognizer:pinch];
}

- (void)handlePinch:(UIPinchGestureRecognizer *)gestureRecognizer 
{  
	float x= [gestureRecognizer locationInView:(gestureRecognizer.view)].x;
	float y= [gestureRecognizer locationInView:(gestureRecognizer.view)].y;
	float sc=gestureRecognizer.scale;
	int st =gestureRecognizer.state;
    [self.bi raiseEvent:nil event:@"uigesture_pinch::::" params:@[@((float)sc),@((float)x),@((float)y),@((int)st)]];
}  

- (CGPoint) getLocationInWindow:(UIView*)contView :(UIView*)element{
 	CGPoint convertedPoint = [contView convertPoint:element.frame.origin toView:nil];
	return convertedPoint;
}
 
-(float) statusBarHeight
{
    CGSize statusBarSize = [[UIApplication sharedApplication] statusBarFrame].size;
    return statusBarSize.height;
}

#End If
